/*****************************************************************************
 * $Id: blackborder.c,v 1.6 2004/05/06 14:13:33 alainjj Exp $
 * Program under GNU General Public License (see ../COPYING)
 *****************************************************************************/

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <stdlib.h>

#include "config.h"
#include "channel.h"
#include "plugin.h"
#include "blackborder.h"
#include "commands.h"

extern PLUGIN *plugin;
void update_blackborder(void);

static int ybar_ratio = 0;

static inline int scale (int l, int lold, int lnew) {
  return (l * lnew + (lold>>1)) / lold;
}

int get_ybar(int height) {
  return scale(get_ybar_ratio(), YBAR_DEN, height);
}

int get_ybar_ratio(void) {
  if(plugin) {
    int y=scale(plugin->get_ybar(), cur_maxheight, YBAR_DEN);
    if(abs(y-ybar_ratio)<2) /* to make incr/decr work */
      return ybar_ratio;
    else {
      ybar_ratio = y;
      update_blackborder();
      return y;
    }
  }
  else
    return ybar_ratio;
}

void set_ybar_ratio(int y) {
  if(y<0 || y> YBAR_DEN/2) return;
  ybar_ratio = y;
  if(plugin) {
    char cmd[30];
    sprintf(cmd, "blackborder %d", scale(y, YBAR_DEN, cur_maxheight));
    do_command_single(cmd);
  }
  update_blackborder();
}
